import org.maemo.hermes.engine.facebook.service

from org.maemo.hermes.engine.names import canonical


class Service(org.maemo.hermes.engine.facebook.service.Service):
    """LinkedIn backend for Hermes.
                
       Copyright (c) Fredrik Wendt <fredrik@wendt.se> 2010.
       Released under the Artistic Licence."""
       
       
    # -----------------------------------------------------------------------
    def __init__(self, linkedInApi):
        """Initialize the LinkedIn service, finding LinkedIn API keys in gconf and
           having a gui_callback available."""
        
        org.maemo.hermes.engine.facebook.service.Service.__init__(self, None)
        self.linkedInApi = linkedInApi

    
    # -----------------------------------------------------------------------
    def process_friends(self):
        friends = self.linkedInApi.get_friends()
        for friend in friends:
            for url in friend.get_urls():
                self._friends_by_url[url] = friend
            if self._allow_friend_to_match_by_name(friend):
                key = canonical(friend.get_name())
                self._friends_by_name[key] = friend


    # -----------------------------------------------------------------------
    def _allow_friend_to_match_by_name(self, friend):
        for url in friend.get_urls():
            if url in self._known_urls:
                return False
        return True
    
    

